package com.keyboard.bubble.skin.keyboard.myada;


import android.content.Context;
import android.content.Intent;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ImageView;

import androidx.annotation.NonNull;
import androidx.cardview.widget.CardView;
import androidx.recyclerview.widget.RecyclerView;

import com.keyboard.bubble.skin.keyboard.R;
import com.keyboard.bubble.skin.keyboard.bean.ChildBean;
import com.keyboard.bubble.skin.keyboard.mylistener.ItemClickCallback;
import com.keyboard.bubble.skin.keyboard.ui.SetkeyboardActivity;
import com.bumptech.glide.Glide;
import com.keyboard.bubble.skin.keyboard.utils.MyUtils;

import java.util.ArrayList;
import java.util.List;

public class AdapterMain extends RecyclerView.Adapter<AdapterMain.ForYouViewHolder> {

    private Context mContext;
    private List<ChildBean> mList = new ArrayList<>();

    private ItemClickCallback mCallBack;

    public AdapterMain(Context context) {
        mContext = context;
    }

    public void setForYouList(List<ChildBean> list) {
        this.mList = list;
        notifyDataSetChanged();
    }


    public void setClickAction(ItemClickCallback callback) {
        mCallBack = callback;
    }

    @NonNull
    @Override
    public ForYouViewHolder onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view = LayoutInflater.from(mContext).inflate(R.layout.item_main, parent, false);
        return new ForYouViewHolder(view);
    }

    @Override
    public void onBindViewHolder(@NonNull ForYouViewHolder holder, int position) {
        ChildBean childBean = mList.get(position);
        String thumbGif = childBean.getThumbGif();
        String thumb = childBean.getThumbUrl();
        if (!thumbGif.isEmpty()) {
            MyUtils.INSTANCE.loadWepJif(mContext, thumbGif, holder.itemImg);
        } else {
            Glide.with(mContext).load(thumb).into(holder.itemImg);
        }

        holder.cardView.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                Intent intentApply = new Intent(mContext, SetkeyboardActivity.class);
                intentApply.putExtra(SetkeyboardActivity.SOURCE_KEY, childBean);
                intentApply.putExtra(SetkeyboardActivity.DISPLAY_URL_KEY, childBean.getImgPath());
                intentApply.putExtra(SetkeyboardActivity.ZIP_URL_KEY, childBean.getZipPath());
                intentApply.putExtra(SetkeyboardActivity.NAME_KEY, childBean.getTitleName());
                intentApply.putExtra(SetkeyboardActivity.GIF_KEY, childBean.getImgGif());
                String intent_thumb;
                if (!thumbGif.isEmpty()) {
                    intent_thumb = thumbGif;
                } else {
                    intent_thumb = thumb;
                }
                intentApply.putExtra(SetkeyboardActivity.THUMB_KEY, intent_thumb);
                mContext.startActivity(intentApply);
                if (mCallBack != null) {
                    mCallBack.OnItemClickListener();
                }

            }
        });


    }

    @Override
    public int getItemCount() {
        return mList.size();
    }

    public static class ForYouViewHolder extends RecyclerView.ViewHolder {

        private CardView cardView;
        private ImageView itemImg;

        public ForYouViewHolder(@NonNull View itemView) {
            super(itemView);
            cardView = itemView.findViewById(R.id.card_view);
            itemImg = itemView.findViewById(R.id.imPreview);

        }

    }

//    private void loadWepJif(String webpGifUrl,ImageView view){
//        Glide.with(mContext).load(webpGifUrl).addListener(new RequestListener<Drawable>() {
//            @Override
//            public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
//                return false;
//            }
//
//            @Override
//            public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
//               if(resource instanceof WebpDrawable){
//                   WebpDrawable webpDrawable = (WebpDrawable) resource;
//                   webpDrawable.setLoopCount(LOOP_FOREVER);
//               }
//
//                return false;
//            }
//        }).into(view);
//    }
}
